//Programming for Games 1 - Assignment 1 - Coin Game
// Created by Matthew Tinn

//REFERENCES
//Pseudo random number generator code was referenced from 
//Swartz, F. (2003) C++ Notes: Random Numbers Available at: http://www.fredosaurus.com/notes-cpp/misc/random.html (Accessed: 27 October 2010)
//was mainly used for using the system clock as the seed so that the random numbers were different. From what I can see
//this was the best solution to getting the random numbers working in my opinion and it helped me understand how seeds are
//supposed to work

// 17/12/11     Matthew Tinn
// Updated release version with an exit character loop.

#include <iostream> //includes the IO stream library
#include <cstdlib> // includes the c standard libraby for psuedo random number generation
#include <ctime> //includes library for time for pseduo random number generator
using namespace std;

void numPenniesLeft(int numOfPenniesLeft) //this subprogram displays the number of pennies that remain
{
	cout << " \nThe number of pennies left is:" << endl; // where \n appears the text is put on a new line

	for (int numPennyCount = numOfPenniesLeft; numPennyCount <= numOfPenniesLeft && numPennyCount > 0; numPennyCount--)
	{
		cout << "O";  //this for loop outputs 'O' while 0 < numPennyCount <= numOfPenniesLeft then decrements numPennyCount
	}

	cout <<  "\n" << numOfPenniesLeft << endl; //also outputs the number of pennies left as a number for convenience so the player doesn't have to count all the 'O's
}

int playerRemovePennies (int &numPennies) //this subprogram lets the player remove pennies. Passed by ref as the value should PERMANANTLY change
{
	int penniesTakenOut = 0; //integer variable stores the input pennies taken out by player
	bool inputAccepted = false; //boolean variable catches single chracter input errors

	while (inputAccepted == false) //loops until the player enters the correct input
	{
	  cout << "\nIt's player 1's turn." << endl;
	  cout << "Enter how many pennies to take out.  "; //asks player how many pennies they want to take out
	  cin >> penniesTakenOut; //stores the input number of pennies into penniesTakenOut

	  if (penniesTakenOut >= 1 && penniesTakenOut <= 5) //validation - if the number of pennies is in the correct range follow through
	  {
		if (numPennies > 4) //this section of code stops the player from taking away more pennies than there are left.
		{
	      inputAccepted = true; //if the number of pennies left is greater than 4 just accept the nput as the max yo ucan take out is 5 and
		}						//5-5=0
		else
		{
			if (numPennies == 4) //for each less than 5, only accept input if the number of pennies that the player wants to take out
			{						//is less than or equal to the number of pennies left.
				if (penniesTakenOut <= 4) //this stops the program from displaying a negative number of pennies left
				{
					inputAccepted = true;
				}
			}
			else if (numPennies == 3)
			{
				if (penniesTakenOut <= 3)
				{
					inputAccepted = true;
				}
			}
			else if (numPennies == 2)
			{
				if (penniesTakenOut <= 2)
				{
					inputAccepted = true;
				}
			}
			else if (numPennies == 1)
			{
				if (penniesTakenOut == 1)
				{
					inputAccepted = true;
				}
			}
		}
		if (inputAccepted == true)
		{
	    numPennies = numPennies - penniesTakenOut; //subtracts the input num of pennies from the current toal pennies
		}
		else
		{	//informs the player when they've tried to take out more pennies than there are pennies left
			cout << "You have tried to take out more pennies than you have left." <<endl;
		}
	  }
	  else //if the input is not valid
	  {
	    cout << "Error in input. Try again." << endl; //ouptuts error
	  }
	}
	numPenniesLeft(numPennies); //calls the subprogram to display the number of pennies as 'O's
	return numPennies; //returns to main the number of pennies
}

int comRemovePennies (int &comNumPennies) //comNumPennies is imply the current number of pennies from main
{
	int comPenniesTakenOut = 0; //this varaible will store a random number between 1 and 5 that will be subtracted from the current number of pennies
	
	if (comNumPennies >= 7) //this section of if...else statements controls what the computer takes out
	{						//depending on how many coins are left.
		srand((unsigned)time(0)); //uses the system clock to seed the pseudo random number generator so that the psu. random no. is more unpredictable
		comPenniesTakenOut = (rand() %5) + 1;//uses the psudeo random number generator to generate a number between 1 and 5
	}
	else if (comNumPennies == 6) //when less than 7 coins remain always takes out enough to leave the player to take the last coin.
	{
		comPenniesTakenOut = 5;
	}
	else if (comNumPennies == 5)
	{
		comPenniesTakenOut = 4;
	}
	else if (comNumPennies == 4)
	{
		comPenniesTakenOut = 3;
	}
	else if (comNumPennies == 3)
	{
		comPenniesTakenOut = 2;
	}
	else if (comNumPennies == 2 || comNumPennies == 1) //takes out 1 coin when the num of coisn left is 2 OR 1.
	{
		comPenniesTakenOut = 1;
	}

	comNumPennies = comNumPennies - comPenniesTakenOut; //takes the selected amoutn of pennies away from the total number of pennies reamaining
	numPenniesLeft (comNumPennies); //calls the numPenniesLeft subprogram
	return comNumPennies; //returns the number of pennies left to the main subprogram for use in the other subprograms
}

void main () //main function
{
	int numberOfPennies = 25; //this variable hold the value of the number of pennies

	int playerTimesWon = 0; //this varibale counts the number of times that the player has won

	int comTimesWon = 0; //this variable counts hwo many times the computer has won

	//the number of times the player and computer have won are displayed at the end of each game

	char playerTurn = ' '; //this varibale records whose turn it is. This makes the person who goes first easily changeable

	int numberOfGames = 1; //this variable stores the number of games played

	char exitChar = ' '; //A charcter that when entered will exit the program

	cout << "GRAB THE COINS!" << endl; //this output is information for the player
	cout << "Be the player not to grab the last coin." << endl; //basic rules and instructions before game starts
	cout << "When prompted enter a number between 1 and 5 to remove that number of coins." << endl;
	
	while (numberOfGames <=5) //this while loop limits the overall game to 5 'rounds'
	{
	  numberOfPennies = 25; //this is the initial setting of the number of peenies at the start of each game

	  cout << "\nCurrent score:" << endl; //this section of code is info for the player
	  cout << "Player - " << playerTimesWon << endl; //displays the current scores and tells them what the current game number is
	  cout << "Computer - " << comTimesWon << endl;
	  cout << "\nStarting game " << numberOfGames << "..." << endl;

	  while (numberOfPennies > 0)
	  {
	    playerTurn = 'p'; //you can change this to c and the computer will start first
	    if (playerTurn == 'p') //so player starts first
	    {
	      playerRemovePennies(numberOfPennies); //calls the function where the player wil lremove their pennies
	    }
	    if (numberOfPennies > 0) //checks first that there's pennies left
	    {
	      playerTurn = 'c'; //again this can be changed to p
	    }
	    if (playerTurn == 'c')
	    {
	      cout << "\nIt's the computer's turn." << endl;
		  cout << "The computer chooses how many pennies to withdraw." << endl;
		  comRemovePennies(numberOfPennies); //calls the function where the computer removes pennies
	    }
	  }
	  if (playerTurn == 'p') //this section tests the win/lose condition when pennies are zero
	  {							//if theg ame ends on the player's turn the player took the last coin so they lose
	    cout << "You lose." << endl;
		comTimesWon = comTimesWon + 1;
	  }
	  else //if the game did not end on the player's turn, they won as they did not take the last coin
	  {
	    cout << "You win!" << endl;
		playerTimesWon = playerTimesWon + 1;
	  }

	  numberOfGames = numberOfGames + 1; //increments the number of games
	}

	cout << "\nGAME, SET AND MATCH!" <<endl; //this section is displayed when 5 games have been played
	cout << "\nPlayer won " << playerTimesWon << " games; and computer won " << comTimesWon << " games." << endl; //shows how many times the player and computer have won
	if (playerTimesWon > comTimesWon) //this shows the player how many games they beat the computer by
	{
	  cout << "You beat the computer by " << (playerTimesWon - comTimesWon) << " games." << endl;
	}
	else //this shows the player how many games the computer beat them by
	{
	  cout << "The computer beat you by " << (comTimesWon - playerTimesWon) << " games." << endl;
	}

	cout << "Enter any key to exit:    ";
	cin >> exitChar;
}

	    
