//Programming Assignment 2
//RPG Character Name and Background Generator
//Code written by Matthew Tinn

#include <iostream>
#include <time.h> //time library for seeding random number generator
#include <string.h> //c string library for using null-terminated character string functions
using namespace std;

//constants indicate where each attribute is stored
//in attributes array
const int STRENGTH = 0; //stores position of strength
const int AGILITY = 1; //stores position of agility
const int TOUGHNESS = 2; //stores position of toughness
const int INTELLIGENCE = 3; //stores position of intelligence
const int CHARISMA = 4; //stroes postion of charisma

void chooseNames(char name[], int arrNameSize, char sex) //selects the character's name
{
  int randomNumber = 0; //stores random number
  randomNumber = (rand()%6) + 1; //generates random number between 1 & 6
	
  //choosing a character name. dependant on gender.
  if (sex == 'M') //male names
  { //selects the name depending on the random number
	if (randomNumber == 1)
	{
	  strcpy(name, "Tom"); //copies name to name array using strcpy.	
	}

	else if (randomNumber == 2)
	{
	  strcpy(name, "Jack");
	}
	
	else if (randomNumber == 3)
	{
	  strcpy(name, "Matt");
	}

	else if (randomNumber == 4)
	{
	  strcpy(name, "Chris");
	}

	else if (randomNumber == 5)
	{
	  strcpy(name, "David");
	}

	else if (randomNumber == 6)
	{
	  strcpy(name, "Maurice");
	}
  }

  else //female names
  { //selects the name depending on the random number
    if (randomNumber == 1)
	{
	  strcpy(name, "Sarah");
	}

	else if (randomNumber == 2)
	{
	strcpy(name, "Karen");
	}

	else if (randomNumber == 3)
	{
	  strcpy(name, "Ruby");
	}

	else if (randomNumber == 4)
	{
	strcpy(name, "Jenny");
	}

	else if (randomNumber == 5)
	{
	  strcpy(name, "Jane");
	}

	else if (randomNumber == 6)
	{
	  strcpy(name, "Alice");
	}
  }
}

void chooseDescriptors (char descriptor[], int arrDescriptorSize) //selects a descriptor
{
  int randomNumber = 0;
  //generate random number between 1 and 10
  randomNumber = (rand()%10) + 1;
  //selects the descriptor to be used depending on the random number
  if (randomNumber == 1)
  {
    strcpy(descriptor, "Bloodthirtsy");
	//copies the correct descriptor to descriptor array using strcpy
  }

  else if (randomNumber == 2)
  {
    strcpy(descriptor, "Gambler");
  }

  else if (randomNumber == 3)
  {
    strcpy(descriptor, "Red-eyed Pirate");
  }

  else if (randomNumber == 4)
  {
    strcpy(descriptor, "Bearer of Hope");
  }

  else if (randomNumber == 5)
  {
    strcpy(descriptor, "Benevolent Ruler");
  }
  
  else if (randomNumber == 6)
  {
    strcpy(descriptor, "Lone Warrior");
  }

  else if (randomNumber == 7)
  {
    strcpy(descriptor, "Ravaging Beast");
  }

  else if (randomNumber == 8)
  {
    strcpy(descriptor, "Monstrous Fiend");
  }

  else if (randomNumber == 9)
  {
    strcpy(descriptor, "Humble");
  }

  else if (randomNumber == 10)
  {
    strcpy(descriptor, "Rogue");
  }
}

int sumOfAttributes (int totalAttr, int attrArray[], int size) 
//(re)calculates the toal number of attributes
{
  totalAttr = 0; //resets the total number of attributes to 0 for recalculation
  //adds each of the attributes in the array together using for loop
  for(int i = 0; i < size; i++)
  {
    totalAttr = totalAttr + attrArray[i]; //adds current attribute value to total
  }

  return totalAttr; //returns the total number of attributes
}

void setAttributes (int attributesArray[], int attrSize) //subprogram sets the values of the attributes
{
  int randNum = 0; //holds random number
  int totalAttributes = 0; //holds sum of attributes

  //randomly generates a value for each attribute
  randNum = (rand()%10) + 1; //generates random number between 1 & 10
  attributesArray[STRENGTH] = randNum; //stores random number in array
  //for each attribute, generates a new random number and stores it into the correct array position
  randNum = (rand()%10) + 1;
  attributesArray[AGILITY] = randNum;

  randNum = (rand()%10) + 1;
  attributesArray[TOUGHNESS] = randNum;

  randNum = (rand()%10) + 1; 
  attributesArray[INTELLIGENCE] = randNum;

  randNum = (rand()%10) + 1;
  attributesArray[CHARISMA] = randNum;
  
  //calls subprogram to calculate the total number of attributes
  totalAttributes = sumOfAttributes(totalAttributes, attributesArray, attrSize);

  //checks that the total number of attributes is in the required range
  if (totalAttributes < 15) //if the total attributes is less than 15 it has to increase it to 15
  {
    for(int i = 0; i < attrSize; i++)
	{ //goes through each attribute while number of attributes < 15 and adds 1 to them until
	  //the correct total number of attributes is reached
	  while (totalAttributes < 15)
	  {
	    if (attributesArray [i] < 10)
	    { //adds 1 to the relevant attribute if the attribute is < 10
		  attributesArray[i] = attributesArray[i] + 1; 
	    }
		//recalculate total number of attributes
	    totalAttributes = sumOfAttributes(totalAttributes, attributesArray, attrSize);
	  }
	}
  }
  // if the total number of attributes was too large:
  else if (totalAttributes > 35)
  { 
    for(int j = 0; j < attrSize; j++) //goes through each attribute while number of attributes > 35 and subtracts 1 from
	{ //them until the correct total number of attributes is reached
	  while (totalAttributes > 35)
	  {
	    if (attributesArray[j] > 1)
	    { //subtracts 1 from the relevant attribute if the attribute > 1
	      attributesArray[j] = attributesArray[j] - 1;
	    }
		//recalculate the total number of attributes
        totalAttributes = sumOfAttributes(totalAttributes, attributesArray, attrSize);
	  }
	}
  }
}

void createHistory(char background[], int bgSize, char arrName[], int nameArraySize, int arrAttributes[], int attributesArraySize, char sex)
{ //creates the background history for the character

  int randNumber; //stores a random number
  int numberOfSentences = 0; 
  //controls the number of sentences stored in the background array
  //initially set as 0 for the for loop

  //boolean variables to prevent same line going into the background more than once
  bool usedTown = false;
  bool usedHobby = false;
  bool usedMoment = false;
  bool usedSong = false;
  bool usedAsAChild = false;
  bool usedBattleFaction = false;
  bool usedMasterOf = false;
  bool usedMarried = false;
  bool inputToArray = false;

  char hometown[10]; //array to store the hometown
  char hobby[30]; //array to store the hobby
  char bestMoment[40]; //array to store the character's best moment in life
  char faveSong[40]; //array to store the character's favourite song
  char asAChild[100]; //array to stor the character's best moment as a child
  char battleFaction[100]; //array to store the faction that the character has battled against
  char masterOf[20]; //array to store the skill or weapon that the character has mastered
  char marriedTo[50]; //array to store the person the character is married to

  //copies what is stored in the full name array to the background array
  strcpy(background, arrName);

  //determine's the character's hometown
  randNumber = (rand()%5) + 1; //generates a random number between 1 and 5
  if (randNumber == 1)
  { //selects the hometown based on the random number
    strcpy(hometown, "Harjel"); //copies the selected hometown into the hometown array
  }
  else if  (randNumber == 2)
  {
    strcpy(hometown, "Gardias");
  }
  else if (randNumber == 3)
  {
    strcpy(hometown, "Juku");
  }
  else if (randNumber == 4)
  {
    strcpy (hometown, "Boornton");
  }
  else if (randNumber == 5)
  {
    strcpy(hometown, "Choville");
  }

  //determines the character's hobby
  randNumber = (rand()%5) + 1; //generates a random number between 1 & 5
  if (randNumber == 1)
  { //selects the hobby based on the random number
    strcpy(hobby, "stealing sweets"); //copies the selected hobby into the hobby array
  }
  else if  (randNumber == 2)
  {
    strcpy(hobby, "slaying hideous demons");
  }
  else if (randNumber == 3)
  {
    strcpy(hobby, "eating apple pies");
  }
  else if (randNumber == 4)
  {
    strcpy (hobby, "singing");
  }
  else if (randNumber == 5)
  {
    strcpy(hobby, "baking cakes");
  }

  //determine's the character's notable moment in life
  randNumber = (rand()%5) + 1; //generates a random number between 1 & 5
  if (randNumber == 1)
  { //selects moment based on random number
    strcpy(bestMoment, "defeating the forces of evil"); //copies the selected moment into the bestMoment array
  }
  else if  (randNumber == 2)
  {
    strcpy(bestMoment, "accumulating 10 million gold");
  }
  else if (randNumber == 3)
  {
    strcpy(bestMoment, "plunging the world into darkness");
  }
  else if (randNumber == 4)
  {
    strcpy (bestMoment, "saving a friend from certain death");
  }
  else if (randNumber == 5)
  {
    strcpy(bestMoment, "drawing some good artwork");
  }

  //determine's the character's favourtie song
  randNumber = (rand()%5) + 1; //generates a random number between 1 & 5
  if (randNumber == 1)
  { //selects song based on random number
    strcpy(faveSong, "Curses by DedPirate"); //copies the selected song into the faveSong array
  }
  else if  (randNumber == 2)
  {
    strcpy(faveSong, "Nani jin desu ka? by Cross-Op");
  }
  else if (randNumber == 3)
  {
    strcpy(faveSong, "Ye Shall See Well by Elya Carthos");
  }
  else if (randNumber == 4)
  {
    strcpy (faveSong, "Comith Hether by Shards of Wine");
  }
  else if (randNumber == 5)
  {
    strcpy(faveSong, "Anata Yume by Yashika-chan");
  }

  //Determines the character's best moment as a child
  randNumber = (rand()%5) + 1; //generates a random number between 1 & 5
  if (randNumber == 1)
  { //selects moment based on random number
    strcpy(asAChild, "making a blueberry pie"); //copies the moment into the asAChild array
  }
  else if  (randNumber == 2)
  {
    strcpy(asAChild, "learning to play the guitar");
  }
  else if (randNumber == 3)
  {
    strcpy(asAChild, "playing in the Deep Wood");
  }
  else if (randNumber == 4)
  {
    strcpy (asAChild, "working on a farm");
  }
  else if (randNumber == 5)
  {
    strcpy(asAChild, "being abducted by goblins");
  }

  //Determines who the character fought a battle against
  randNumber = (rand()%5) + 1; //generates a random number between 1 & 5
  if (randNumber == 1)
  { //selects faction based on random number
    strcpy(battleFaction, "Dark Lord Morrin"); //copies faction into battleFaction array
  }
  else if  (randNumber == 2)
  {
    strcpy(battleFaction, "Dawescona");
  }
  else if (randNumber == 3)
  {
    strcpy(battleFaction, "The Union of the Shadow Kingdoms");
  }
  else if (randNumber == 4)
  {
    strcpy(battleFaction, "The Cryothis Kingdom");
  }
  else if (randNumber == 5)
  {
    strcpy(battleFaction, "The Gorshii Republic");
  }

  //Determines what the character is master of
  randNumber = (rand()%5) + 1; //generates a random number between 1 & 5
  if (randNumber == 1)
  { //selects item based on random number
    strcpy(masterOf, "the sword"); //copies the item into the masterOf array
  }
  else if  (randNumber == 2)
  {
    strcpy(masterOf, "magic");
  }
  else if (randNumber == 3)
  {
    strcpy(masterOf, "death");
  }
  else if (randNumber == 4)
  {
    strcpy (masterOf, "compassion");
  }
  else if (randNumber == 5)
  {
    strcpy(masterOf, "the bow");
  }
    
  //Determines who he/she is married to
  randNumber = (rand()%4) + 1; //generates a random number between 1 & 5
  if (randNumber == 1)
  { //selects perosn based on random number
    if (sex == 'M') //person determiend by gender. m can marry F and vice versa.
	{
      strcpy(marriedTo, "Janie the Housewife");
	}
	else
	{
	  strcpy(marriedTo, "Darius the Blacksmith");
	}
  }
  else if  (randNumber == 2)
  {
    if (sex == 'M')
	{
	  strcpy(marriedTo, "Lauren the Sorceress");
	}
	else
	{
      strcpy(marriedTo, "Martin the Warrior");
	}
  }
  else if (randNumber == 3)
  {
    if (sex =='M')
	{
    strcpy(marriedTo, "Lady Scarlett");
	}
	else
	{
	  strcpy(marriedTo, "Lord Emeratt");
	}
  }
  else if (randNumber == 4)
  {
    if (sex == 'M')
	{
	  strcpy(marriedTo, "his childhood friend, Emma");
	}
	else
	{
      strcpy(marriedTo, "her childhood sweetheart, Andrew");
	}
  }

  //store the full character background in the c-string array
  strcpy(background, arrName);

  //randomly generates sentences, concatenating them onto the background array with the appropriate random words
  for(numberOfSentences = 0; numberOfSentences <= 4; numberOfSentences++) //limited to 4 sentences
  {
    inputToArray = false; //nothing has been input to the array yet. simply used to continuously loop
							//to input the 4 sentences
	while (inputToArray == false) //while nothing has been input into the array
	{
    randNumber = (rand()%8) + 1; //generate a random number between 1 & 8
	if (randNumber == 1 && usedTown == false) //sentence 1 = hometown
	{ 
	  if (numberOfSentences == 0)
	  { //if it's the first sentence combine with the name
	    strcat(background, "'s hometown is ");
	  }
	  else //if not first sentence
	  {
	    if (sex == 'M')
		{ //use this if male
		  strcat(background, "\nHis hometown is ");
		}
		else
		{ //use this if female
		  strcat(background, "\nHer hometown is ");
		}
	  }
	  strcat(background, hometown); //concatenate the hometown on to the background array
	  strcat(background, ". "); //add a full stop
	  usedTown = true; //set usedTown to true to stop it form beign used again
	  inputToArray = true; //input it to array so true
	}

	if (randNumber == 2 && usedHobby == false) //sentence 2 = hobby
	{
	  if (numberOfSentences == 0)
	  {//if it's the first sentence combine with the name
	    strcat(background, " really enjoys ");
	  }
	  else //if not first sentence
	  {
	    if (sex == 'M')
		{//use this if male
		  strcat(background, "\nHe really enjoys ");
		}
		else
		{//use this if female
		  strcat(background, "\nShe really enjoys ");
		}
	  }
	  strcat(background, hobby); //concatenates the hobby onto the background array
	  strcat(background, ". "); //adds a full stop
	  usedHobby = true; //sets usedHobby to true to stop this sentence being used again
	  inputToArray = true;
	}

	if (randNumber == 3 && usedMoment == false) //sentence 3 = best moment
	{
	  if (numberOfSentences == 0)
	  {//if it's the first sentence combine with the name
		  strcat(background, "'s most notable moment in life was:\n");
	  }
	  else //if not first sentence
	  { 
	    if (sex == 'M')
		{//use this if male
		  strcat(background, "\nA notable moment in his life was ");
		}
		else
		{//use this if female
		  strcat(background, "\nA notable moment in her life was ");
		}
	  }
	  strcat(background, bestMoment); //concatenates bestMoment onto background array
	  strcat(background, ". "); //adds full stop
	  usedMoment = true; //sets usedMoment to true to stop it being used again
	  inputToArray = true;
	}

	if (randNumber == 4 && usedSong == false) //sentence 4 = fave song
	{
	  if (numberOfSentences == 0)
	  {//if it's the first sentence combine with the name
	    strcat(background, "'s favourite song is ");
	  }
	  else //if not first sentence
	  {
	    if (sex == 'M')
		{//use this if male
		  strcat(background, "\nHis favourite song is ");
		}
		else
		{//use this if female
		  strcat(background, "\nHer favourite song is ");
		}
	  }
	  strcat(background, faveSong); //concatenates faveSong onto backgroud array
	  strcat(background, ". "); //adds full stop
	  usedSong = true; //sets usedSong to true so it doesn't get used again
	  inputToArray = true;
	}

	if (randNumber == 5 && usedAsAChild == false) //sentence 5 = best moment as a child
	{
	  if (numberOfSentences == 0)
	  {//if it's the first sentence combine with the name
		  strcat(background, "'s best moment as a child was:\n");
	  }
	  else //if not first sentence
	  {
	    if (sex == 'M')
		{//use this if male
			strcat(background, "\nHis best moment as a child was ");
		}
		else
		{//use this if female
		  strcat(background, "\nHer best moment as a child was ");
		}
	  }
	  strcat(background, asAChild); //concatenates asAChild to background
	  strcat(background, ". "); //adds a full stop
	  usedAsAChild = true; //sets usedAsAChild to true to stop it being used again
	  inputToArray = true;
	}

	if (randNumber == 6 && usedBattleFaction == false) //sentence 6 = faction battled against
	{
	  if (numberOfSentences == 0)
	  {//if it's the first sentence combine with the name
	    strcat(background, " fought in the battle against ");
	  }
	  else //if not first sentence
	  {
	    if (sex == 'M')
		{//use this if male
		  strcat(background, "\nHe fought in the battle against ");
		}
		else
		{//use this if female
		  strcat(background, "\nShe fought in the battle against ");
		}
	  }
	  strcat(background, battleFaction); //concatenates battleFaction onto background
	  strcat(background, ". "); //adds a full stop
	  usedBattleFaction = true; //sets usedBattleFaction to true to stop it being used again
	  inputToArray = true;
	}
	
	if (randNumber == 7 && usedMasterOf == false) //sentence 7 = item master of
	{
	  if (numberOfSentences == 0)
	  {//if it's the first sentence combine with the name
	    strcat(background, " is a master of ");
	  }
	  else //if not first sentence
	  {
	    if (sex == 'M')
		{//use this if male
		  strcat(background, "\nHe is the master of ");
		}
		else
		{//use this if female
		  strcat(background, "\nShe is the master of ");
		}
	  }
	  strcat(background, masterOf); //concatenates masterOf onto background
	  strcat(background, ". "); //adds full stop
	  usedMasterOf = true; //sets usedMasterOf to true to stop it being used again
	  inputToArray = true;
	}

	if (randNumber == 8 && usedMarried == false) //sentence 8 = married to
	{
	  if (numberOfSentences == 0)
	  {//if it's the first sentence combine with the name
	    strcat(background, " is married to ");
	  }
	  else //if not first sentence
	  {
	    if (sex == 'M')
		{//use this if male
		  strcat(background, "\nHe is married to ");
		}
		else
		{//use this if female
		  strcat(background, "\nShe is married to ");
		}
	  }
	  strcat(background, marriedTo); //concatenates marriedTo onto background
	  strcat(background, ". "); //adds a full stop
	  usedMarried = true; //sets usedMarried to true to stop it being used again
	  inputToArray = true;
	}
	}
  }
}

void outputHistory (char arrBackground[], int backgroundSize, int arrAttributes[], int arrAttributesSize, char sex)
{ //outputs the character's history and changes the attributes from numbers to sentences

  cout << arrBackground << endl; //ouputs background
  //generate appropraite text for attributes
  //different sentences dependign on gender
  //and changes depending on how high the attribute is
  //strength
  if (arrAttributes[STRENGTH] <= 2)
  {
    if (sex == 'M')
	{
	  cout << "He is that weak he can't lift a box." << endl;
	}
	else
	{
	  cout << "She is a very delicate woman." << endl;
	}
  }
  else if (arrAttributes[STRENGTH] > 2 && arrAttributes[STRENGTH] <= 4)
  {
    if (sex == 'M')
	{
	  cout << "He's strong enough to wield a light weapon." << endl;
	}
	else
	{
	  cout << "She can handle the housework on her own easy enough." << endl;
	}
  }
  else if (arrAttributes[STRENGTH] > 4 && arrAttributes[STRENGTH] <= 6)
  {
    if (sex == 'M')
	{
	  cout << "His strength allows him to wield a decent weapon." << endl;
	}
	else
	{
	  cout << "She can surprisingly punch her own weight." << endl;
	}
  }
  else if (arrAttributes[STRENGTH] > 6 && arrAttributes[STRENGTH] <=8)
  {
    if (sex == 'M')
	{
	  cout << "He can handle heavy armour without any problem." << endl;
	}
	else
	{
	  cout << "She's stronger than most other women." << endl;
	}
  }
  else if (arrAttributes[STRENGTH] > 8)
  {
    if (sex == 'M')
	{
	  cout << "Famed for his strength, he can cause eathquakes with a single punch." << endl;
	}
	else
	{
	  cout << "She's a very muscular woman who can outshine men in strength." << endl;
	}
  }
  //agility
  if (arrAttributes[AGILITY] <= 2)
  {
    if (sex == 'M')
	{
	  cout << "He moves as slow as a tortoise." << endl;
	}
	else
	{
	  cout << "She prefers to take her time, and that's a long time." << endl;
	}
  }
  else if (arrAttributes[AGILITY] > 2 && arrAttributes[AGILITY] <= 4)
  {
    if (sex == 'M')
	{
	  cout << "He walks, but never runs." << endl;
	}
	else
	{
	  cout << "She belives patience is better than haste." << endl;
	}
  }
  else if (arrAttributes[AGILITY] > 4 && arrAttributes[AGILITY] <= 6)
  {
    if (sex == 'M')
	{
	  cout << "He can run with the best of them." << endl;
	}
	else
	{
	  cout << "She can be quick on her feet when needs arise." << endl;
	}
  }
  else if (arrAttributes[AGILITY] > 6 && arrAttributes[AGILITY] <=8)
  {
    if (sex == 'M')
	{
	  cout << "He's a born sprinter with fast reactions." << endl;
	}
	else
	{
	  cout << "She's more agile than most, and truly benefits from that." << endl;
	}
  }
  else if (arrAttributes[AGILITY] > 8)
  {
    if (sex == 'M')
	{
	  cout << "Agile and quick, he can run rings around the most skilled generals." << endl;
	}
	else
	{
	  cout << "Catlike, she could spring across rooftops if she was light enough." << endl;
	}
  }
  //TOUGHNESS
  if (arrAttributes[TOUGHNESS] <= 2)
  {
    if (sex == 'M')
	{
	  cout << "Not tough at all, many call him a girl." << endl;
	}
	else
	{
		cout << "She's a typical woman, screaming when she sees insects & vermin." << endl;
	}
  }
  else if (arrAttributes[TOUGHNESS] > 2 && arrAttributes[TOUGHNESS] <= 4)
  {
    if (sex == 'M')
	{
	  cout << "He's cowardly and believes in a fair fight." << endl;
	}
	else
	{
	  cout << "A mean face strikes fear into her warm heart." << endl;
	}
  }
  else if (arrAttributes[TOUGHNESS] > 4 && arrAttributes[TOUGHNESS] <= 6)
  {
    if (sex == 'M')
	{
	  cout << "He can stand up to the average person, but not generals and kings." << endl;
	}
	else
	{
	  cout << "She has courage enough to deal with men." << endl;
	}
  }
  else if (arrAttributes[TOUGHNESS] > 6 && arrAttributes[TOUGHNESS] <=8)
  {
    if (sex == 'M')
	{
	  cout << "The only people he bows to are kings." << endl;
	}
	else
	{
	  cout << "She can take care of herself most of the time." << endl;
	}
  }
  else if (arrAttributes[TOUGHNESS] > 8)
  {
    if (sex == 'M')
	{
	  cout << "Hard and burly, his emotions are like stone." << endl;
	}
	else
	{
	  cout << "She is very man-like and doesn't need protection from others." << endl;
	}
  }
  //INTELLIGENCE
  if (arrAttributes[INTELLIGENCE] <= 2)
  {
    if (sex == 'M')
	{
	  cout << "His stupidity has made him a legend." << endl;
	}
	else
	{
		cout << "Not knowing much at all, she's only good for bearing children." << endl;
	}
  }
  else if (arrAttributes[INTELLIGENCE] > 2 && arrAttributes[INTELLIGENCE] <= 4)
  {
    if (sex == 'M')
	{
	  cout << "He has at least some common sense." << endl;
	}
	else
	{
	  cout << "She might not know a lot, but she has a kind heart." << endl;
	}
  }
  else if (arrAttributes[INTELLIGENCE] > 4 && arrAttributes[INTELLIGENCE] <= 6)
  {
    if (sex == 'M')
	{
	  cout << "He can read, write and add numbers with ease." << endl;
	}
	else
	{
	  cout << "Educated as much as she needs to be, she shows good wit at times." << endl;
	}
  }
  else if (arrAttributes[INTELLIGENCE] > 6 && arrAttributes[INTELLIGENCE] <=8)
  {
    if (sex == 'M')
	{
	  cout << "He shows good promise as a man who can further the world's development." << endl;
	}
	else
	{
	  cout << "Smarter than most, she can read people very well." << endl;
	}
  }
  else if (arrAttributes[INTELLIGENCE] > 8)
  {
    if (sex == 'M')
	{
	  cout << "He is a great scholar, admired by all." << endl;
	}
	else
	{
	  cout << "She can calculate how far to the sun and back in parsecs." << endl;
	}
  }
  //CHARISMA
  if (arrAttributes[CHARISMA] <= 2)
  {
    if (sex == 'M')
	{
	  cout << "He has very low charisma." << endl;
	}
	else
	{
		cout << "She has very low charisma." << endl;
	}
  }
  else if (arrAttributes[CHARISMA] > 2 && arrAttributes[CHARISMA] <= 4)
  {
    if (sex == 'M')
	{
	  cout << "He has some charisma, but not much." << endl;
	}
	else
	{
	  cout << "She has some charisma, but not much." << endl;
	}
  }
  else if (arrAttributes[CHARISMA] > 4 && arrAttributes[CHARISMA] <= 6)
  {
    if (sex == 'M')
	{
	  cout << "He is more charismatic than some, but less than others." << endl;
	}
	else
	{
	  cout << "She is more charismatic than some, but less than others." << endl;
	}
  }
  else if (arrAttributes[CHARISMA] > 6 && arrAttributes[CHARISMA] <=8)
  {
    if (sex == 'M')
	{
	  cout << "He has a high level of charisma." << endl;
	}
	else
	{
	  cout << "She has a high level of charisma." << endl;
	}
  }
  else if (arrAttributes[CHARISMA] > 8)
  {
    if (sex == 'M')
	{
	  cout << "He shines charisma." << endl;
	}
	else
	{
	  cout << "She shines charisma." << endl;
	}
  }
}

void main ()
{
  //ARRAY CONSTANTS
  const int FULL_NAME_SIZE = 60;//size constant for fullName array
  const int NAME_SIZE = 30;//size constant for name array
  const int DESCRIPT_SIZE = 30;//size consatnt for descriptor array
  const int ATTRIBUTE_SIZE = 5;//size constant for attributes array
  const int BACKGROUND_SIZE = 300;//size constant for backgorund array

  //ARRAYS
  char charName[NAME_SIZE];
  //array for storing the name of the character
  char charDescriptor[DESCRIPT_SIZE];
  //array for storing a character's descriptor
  char fullName[FULL_NAME_SIZE]; 
  //array for storing the name and descriptor in a single string
  int attributes[ATTRIBUTE_SIZE];
  //array for storing the character's attributes
  char charBackground[BACKGROUND_SIZE];
  //array for storing the character's background history

  //VARIABLES
  int randomNumber = 0; //random number for random selection
  char gender = ' '; //stores the character's gender
  bool nameFirst = true; //variable sets whether the output is
  //[name] 'the' [descriptor] or [discriptor] [name]
  char exitChar = ' '; //character that controls the end of the program
	
  cout << "Character Name & Background Generator --- Final Build ---" << endl;
  cout << "--- Created by Matthew Tinn ---\n" << endl;
  cout << "This program creates random character names and backgrounds." << endl;
  cout << "Please wait while the name and background of a character is generated...\n" << endl;

  srand((unsigned)time(NULL)); //seeds random number generator
  randomNumber = (rand()%2) + 1; //rand num either 1 or 2

  if (randomNumber == 1) //this sets the gender of the character
  {
    gender = 'M';
  }
  else
  {
    gender = 'F';
  }

  randomNumber = (rand()%10) + 1; //rand num 1-10

  if (randomNumber <=5) //this randomly generates the output order of name and descriptor
  {
    nameFirst = true; //sets output to [name] 'the' [descriptor]
  }
  else if (randomNumber >5 && randomNumber <=10)
  {
    nameFirst = false; //sets output to [descriptor] [name]
  }

  //calls subprogram to choose the character's name
  chooseNames(charName, NAME_SIZE, gender);

  //calls subprogram to choose charcter's descriptor
  chooseDescriptors(charDescriptor, DESCRIPT_SIZE);

  //copy the name and descriptor into the fullName array
  //order of strcpy set by nameFirst
  if (nameFirst == true)
  { //copies name in first
    strcpy(fullName, charName);
    strcat(fullName, " the "); //concatenates 'the' then descriptor
	strcat(fullName, charDescriptor);
  }
  else
  { //copies descriptor in first
    strcpy(fullName, charDescriptor);
    strcat(fullName, " "); //concatenates a space then the charcter's name
	strcat(fullName, charName);
  }

  //calls subprogram to set the attributes
  setAttributes(attributes, ATTRIBUTE_SIZE); 
  
  //call subprogram to create and store the character history
  createHistory(charBackground, BACKGROUND_SIZE, fullName, FULL_NAME_SIZE, attributes, ATTRIBUTE_SIZE, gender);

  //call subprogram to handle the output of the character history
  outputHistory(charBackground, BACKGROUND_SIZE, attributes, ATTRIBUTE_SIZE, gender);

  //inform user program has finished and tell them what to do to exit program
  cout << "\nCharacter generated." << endl;
  cout << "When finished, type a character and press enter to exit.";
  cin >> exitChar;
}