//Programming for Games 1 - Assignment 3
//Simple Solitaire
//Author: Matthew Tinn
//Build: 1.00 VS2010
//Last Edit Date: 02/01/2011

//#included libraries
#include <iostream>
using namespace std;

//Global Array Size Constants
const int BOARD_ARRAY_SIZE_SQUARE = 5; //constant for the square dimension of the game board

//Main Program

void displayTitle()
//This displays the title of the game
{
  cout << "*** *** *   *** *** *** *** **  ***" << endl;
  cout << "*   * * *    *   *  * *  *  * * *  " << endl;
  cout << "*** * * *    *   *  ***  *  * * ***" << endl;
  cout << "  * * * *    *   *  * *  *  **  *  " << endl;
  cout << "*** *** *** ***  *  * * *** * * ***\n" << endl;
  cout << "     Created by Matthew Tinn." << endl;
  cout << "        Build 1.00 VS2010" <<endl;
  cout << "___________________________________\n" << endl;
}



void displayInstructions()
//This displays the instructiosn to the player.
{
  char startKey = ' ';
  //Simply a load of cout statements that give the player information
  cout << "________________________________________________________________\n" << endl;
  cout << "Instructions\n" << endl;
  cout << "The object of the game is to have the least amount of pegs remaining" << endl;
  cout << "at the end." << endl;
  cout << "You are presented with a 5x5 board with pegs and a gap in the middle." << endl;
  cout << "You can move a peg into an unoccupied space by getting one peg and" << endl;
  cout << "making it 'jump' over another, single peg next to it." << endl;
  cout << "You can only move a peg horizonatally or vertaically.\n" << endl;
  cout << "Each turn, you will be asked for the x coordinate and the" << endl;
  cout << "y coordinate of the peg you wish to move." << endl;
  cout << "The x coordinate is the column number and the y coordinate is the" << endl;
  cout << "row number." << endl;
  cout << "The coordinates start at (1,1) at the bottom left." << endl;
  cout << "You will then be asked for a direction. Enter one of the following in" << endl;
  cout << "capitals: N, E, S, W. You can also enter Q to change the peg or I to" << endl;
  cout << "display the instructions again." << endl;
  cout << "Keep doing this until there are no more possible moves.\n" << endl;
  cout << "When there are no possible moves remaining, enter 0 foir both the" << endl;
  cout << "x and y coordinates to end the game and calculate your score." << endl;

  cout << "\nEnter any key and press enter to start or continue the game.  ";
  cin >> startKey;
  cout << "________________________________________________________________" << endl;
}

void askToDisplayInstructions()
//This asks the player if they want to display the instructions
{
  //Varibles
  //variable to store player input for their answer to the question
  char instructionsDisp = ' ';
  //boolean variable to check that the user has input a valid character
  bool instructionsInputAccepted = false;

  //Ask user if they'd like to read instructions
  cout << "\nWould you like to read how to play?  ";
  while (instructionsInputAccepted == false)
  { //loops until the user has input a valid character
    cin >> instructionsDisp;
    if (instructionsDisp == 'Y' || instructionsDisp == 'y')
    { //if user input a Y or y that is a valid positive input
      instructionsInputAccepted = true;
	  //display the instructiosn to the player
	  displayInstructions();
    }

    else if (instructionsDisp == 'N' || instructionsDisp == 'n')
    {
	  //if user inputs N or n that is a valid negative input
      instructionsInputAccepted = true;
	  //Does not display the instructions to the player
	  cout << "Instructions not displayed. Enter I when asked for the" << endl;
	  cout << "direction to display the instructions." << endl;
    }

	else
	{ //anything else is not a valid input and asks the user to try again
	  cout << "The character you have input is not Y, y, N, or n." << endl;
	  cout << "Please try again.  ";
	}
  }
}


void displayBoard(char theBoard[BOARD_ARRAY_SIZE_SQUARE][BOARD_ARRAY_SIZE_SQUARE])
//This displays the board
{
  //for loop for the row
	//i and j are counting variables
  for (int i = 0; i < BOARD_ARRAY_SIZE_SQUARE; i++)
  {
	//adds a line break when it reaches the end of a row
	cout << endl;
    //for loop for the element of a column
	for (int j = 0; j < BOARD_ARRAY_SIZE_SQUARE; j++)
	{
	  //ouputs each element of a row
      cout << theBoard[i][j] << " ";
	}
  }
  cout << endl;
}

void createBoard(char board[BOARD_ARRAY_SIZE_SQUARE][BOARD_ARRAY_SIZE_SQUARE])
//This creates the board
{
  //The board will be created from bottom left to top right
  //So we start at the first element of the last row
  int i = 4; //integer to store the row number
  int j = 0; //integer to store the column number
  
  //the purpose of this loop is to add 'O's and the '.' into the array
  //i and j are counting variables
  for (i = 4; i >= 0; i--)
  {
	for (j = 0; j < BOARD_ARRAY_SIZE_SQUARE; j++)
	{
	  if ( i == 2 && j == 2)
      { //at element (2,2) this is the middle of the board and adds in a '.'
		board[i][j] = '.'; //the '.' represents an empty peg space 
	  }
	  else
	  { //at the other elements adds in a 'O'
	    board[i][j] = 'O'; //the 'O' represents a peg occupying a peg space
	  }
	}
  }
}

int getXCoordinate()
//This gets the  x coordinate from the player
{
  char input = ' '; //varaible for the user input
  int xCoord = 0; //variable to store the coordiante
  bool inputCheck = false; //boolean variable to check the user's input is valid

  while (inputCheck == false) //assumes user input is invalid
  {//loops until the user has entered a valid number 
    cout << "\nEnter a value for the x coordinate.  ";
    cin >> input;
    
    if (input < '0' || input > '5')
    { //if input is not between 0-5 inclusive asks them to enter it again
      cout << "You have entered something that is not a valid coordinate." << endl;
	  cout << "Board coordinates are 1, 2, 3, 4 and 5" << endl;
	  cout << "Enter 0 here and for the y coordinate to exit the game." << endl;
	  cout << "Please make another choice." << endl;
    }
	else
	{//if the input is between 0-5 inclusive accepts input
      switch (input)
	  {//the switch converts the entered character to the correct number for the coordinate
		//and sets accepts the input as valid
	    case '0':
		{
		  xCoord = 0;
		  inputCheck = true;
		}
		    break;
	    case '1':
		{
	      xCoord = 1;
		  inputCheck = true;
		}
			break;
		case '2': 
	    {
		  xCoord = 2;
		  inputCheck = true;
		}
			break;
		case '3': 
		{
		  xCoord = 3;
		  inputCheck = true;
		}
			break;
		case '4': 
		{
		  xCoord = 4;
		  inputCheck = true;
		}
			break;
		case '5': 
		{
	      xCoord = 5;
		  inputCheck = true;
		}
			break;
		default: cout << "\nThe number you have input has not been recognised." << endl;
			break;
	  }
	}
  }

  return xCoord; //returns the value of the x coordinate
}

int getYCoordinate()
//This gets the y coordinate from the player
{
  char input = ' '; //varaible for the user input
  int yCoord = 0; //variable to store the coordiante
  bool inputCheck = false; //boolean variable to check the user's input is valid

  while (inputCheck == false)
  {//loops until the input is valid
    cout << "\nEnter a value for the y coordinate.  "; //asks user for y coord
	cin >> input; //gets user input

	if (input < '0' || input > '5')
	{//if the input is outside the acceptable range informs user
	  cout << "You have entered something that is not a valid coordinate." << endl;
	  cout << "Board coordinates are 1, 2, 3, 4 and 5" << endl;
	  cout << "Enter 0 here if you have entered a 0 in the x coordinate to exit the game." << endl;
	  cout << "Please make another choice." << endl; //gets them to input again
	}
	else
	{//if the input is between 0-5 inclusive accepts input
	  switch (input)
	  {//the switch converts the entered character to the correct number for the coordinate
		  //and sets accepts the input as valid
		  case '0':
		{
		  yCoord = 0;
		  inputCheck = true;
		}
		    break;
	    case '1':
		{
	      yCoord = 1;
		  inputCheck = true;
		}
			break;
		case '2': 
	    {
		  yCoord = 2;
		  inputCheck = true;
		}
			break;
		case '3': 
		{
		  yCoord = 3;
		  inputCheck = true;
		}
			break;
		case '4': 
		{
		  yCoord = 4;
		  inputCheck = true;
		}
			break;
		case '5': 
		{
	      yCoord = 5;
		  inputCheck = true;
		}
			break;
		default: cout << "\nThe number you have input has not been recognised." << endl;
			break;
	  }
	}
  }
  return yCoord; //returns the y coordinate
}

char getDirection(int &xCoord, int &yCoord)
//This gets the direction of movement (N, E, S, W, Q) from player
//Variables passed by ref should permanantly change, storing the new coordinates
{
  //Variables
  char input = ' '; //stores the user input
  bool inputCheck = false; //bool checks the user input is correct
  bool pegAccepted = false; //bool checks peg is what user wants
  char inputDirection = ' '; //stores the direction of the peg's movement

  while (inputCheck == false && pegAccepted == false)
  {//loops while the input is not correct or the user doesn't want the current peg
    cout << "\nEnter the direction you wish to move the peg." << endl;
	cout << "This can be N, E, S, or W." << endl;
	cout << "If you want to move another peg, press Q." << endl;
	cout << "If you want to view the instructions enter I.  ";
	cin >> input;

	if (pegAccepted == false)
	{//sets the inputCheck back to false after the user has entered a new peg
	  inputCheck = false;
	}

	if (input == 'N' || input == 'E' || input == 'S' || input == 'W')
	{//if the user inputs a valid direction
	  inputCheck = true; //input is valid
	  pegAccepted = true; //peg is correct
	  inputDirection = input; //stores the input into inputDirection
	  cout << "Direction confirmed.\n" << endl; //outputs to user the input direction has been stored.
	}
	else if (input == 'Q')
	{//if input is Q
	  //returns user to peg selection stage
	  cout << "Returning to peg selection.\n" << endl;
	  xCoord = getXCoordinate(); //gets a new x coordinate
	  yCoord = getYCoordinate(); //gets a new y coordinate
	}
	else if (input == 'I')
	{
	  askToDisplayInstructions();
	  cout << "\nThe coordinates you have entered are (" << xCoord << "," << yCoord << ")" << endl;
	}
	else
	{ //if user input is not valid informs user and gets them to try again.
	  cout << "You have entered an invalid character." << endl;
	  cout << "Enter only N, E, S, W, Q." << endl;
	  cout << "Please try again.\n" << endl;
    }
  }
  return inputDirection; //returns the input dierection
}

int findArrayElement(int coordinate, char axis)
{//This changes the entered coordinates into the array element
  int arrayElement = 0; //stores the corresponding array element
  if (axis == 'y')
  {//changes the yCoord to the array element
    switch (coordinate)
	{//selects the y coord and stores the correct arrayElement
	  case 1: arrayElement = 4;
	          break;
	  case 2: arrayElement = 3;
		      break;
	  case 3: arrayElement = 2;
	          break;
	  case 4: arrayElement = 1;
		      break;
	  case 5: arrayElement = 0;
		      break;
	  default: cout << "Error: Element does not exist." << endl;
		      break;
	}
  }
  else if (axis == 'x')
  {//changes the xcoord to the array element
	//x coord is just element + 1 so we can just subtract 1 from it
    arrayElement = coordinate - 1;
  }
  return arrayElement; //returns the element of the array
}

void calcCheckPositions(int &checkXPos, int &checkYPos, int positionX, int positionY, char directionOfMove, bool &offBoard, bool alreadyChecked)
{ //this calculates the values for checking x and y for checkMoveIsLegal
  //called once for checking the adjacent peg
  //and again for checking the space the player moves to is unoccupied
  //checking positions should be in/decremented by 1 each time
  //also provides validation for moving off the board
 
  switch (directionOfMove)
  {//determines the position based on the direction which the player wants to move
    case 'N': //north
	{
	  if (alreadyChecked == false)
	  {//check for an adjacent peg
        if (positionY != 0)
		{//if not already on the top row
	      checkYPos = positionY - 1; //get the position 1 space north
		  checkXPos = positionX; //x stays the same
		}
		else
		{// if the peg selected is on the top row informs player
		  cout << "You are currently on the top row, so there is no peg above you." << endl;
		  offBoard = true; //player is attempting to go off the board
		}//end if
	  }
	  else
	  {//check that the player is moving to an empty space
	    if (positionY > 1)
		{//if the player is on the 2nd row or below
		  checkYPos = positionY - 2; //get the position two spaces north
		  checkXPos = positionX;//x stays the same
		}
		else
		{//if player is on a row that will move him/her off the board inform them
          cout << "You tried to move beyond the top row." << endl;
		  offBoard = true; //player is attempting to go off the board
		}//end if
	  }//end if
	  break;
	}//end case
	
	case 'E': //east
    {
	  if (alreadyChecked == false)
	  {//check for an adjacent peg
	    if (positionX < BOARD_ARRAY_SIZE_SQUARE - 1)
		{//if not already on the last column
		  checkXPos = positionX + 1; //get the position 1 space east
		  checkYPos = positionY;//y stays same
		}
		else
		{//if already on the last column inform player
		  cout << "You have tried to move beyond the last column." << endl;
		  offBoard = true; //player is attempting to go off the board
		}//end if
	  }
	  else
	  {//check that the player is moving to an empty space
	    if (positionX < BOARD_ARRAY_SIZE_SQUARE - 2)
		{ //if the player is on the second last column or further west
		  checkXPos = positionX + 2; //get position two spaces east
		  checkYPos = positionY;//y stays same
		}
		else
		{//if player is on a row that will move him/her off the board inform them
		  cout << "You have tried to move beyond the last column." << endl;
		  offBoard = true; //player is attempting to go off the board
		}//end if
	  }//end if
	  break;
	}//end case
	case 'S': //south
	{
      if (alreadyChecked == false)
	  {//check for an adjacent peg
	    if (positionY < BOARD_ARRAY_SIZE_SQUARE - 1)
		{//if not already on the last row 
		  checkYPos = positionY + 1; //get position 1 space south
		  checkXPos = positionX; //x stays same
		}
		else
		{//if player is already on the last row inform them
		  cout << "You are currently on the bottom row, so there is no peg below you." << endl;
		  offBoard = true; //player is attempting to go off the board
		}//end if
	  }
	  else
	  {//check that the player is moving to an empty space
	    if (positionY < BOARD_ARRAY_SIZE_SQUARE - 2)
		{//if the player is on the second last column or futher north
          checkYPos = positionY + 2; //get position 2 spaces south
		  checkXPos = positionX;//x stays same
		}
		else
		{//if player is on a row that will move him/her off the board inform them
		  cout << "You have tried to move beyond the bottom row." << endl;
		  offBoard = true; //player is attempting to go off the board
		}//end if
	  }//end if
	  break;
	}// end case
	case 'W': //west
	{
	  if (alreadyChecked == false)
	  {//check for an adjacent peg
	    if (positionX != 0)
		{//if not already on the first column
		  checkXPos = positionX - 1; //get position 1 space west
		  checkYPos = positionY; //y stays same
		}
		else
		{//if player is already on the first column then inform them
		  cout << "You are already on the first column, so there is no adjacent peg in this direction." << endl;
		  offBoard = true; //player is attempting to go off the board
		}//end if
	  }
	  else
	  {//check that the player is moving to an empty space
	    if (positionX > 1)
		{//if peg selected is not in first 2 rows
		  checkXPos = positionX - 2; //get position 2 sapces west
		  checkYPos = positionY;//y stays same
		}
		else
		{//if player is on a row that will move him/her off the board inform them
		  cout << "You have tried to move to a space before the first column." << endl;
		  offBoard = true; //player is attempting to go off the board
		}//end if
	  }//end if
	  break;
	}//end case
	default: cout << "Error occurred. There is no coordinates set for a peg." << endl;
	break;
  }//end switch

}//end subprogram

bool checkMoveIsLegal(char theBoard[BOARD_ARRAY_SIZE_SQUARE][BOARD_ARRAY_SIZE_SQUARE], int xPos, int yPos, char direction)
//This checks that the move is legal
{
  bool moveIsLegal = false; //boolean to determien whether the move is legal
  int checkX = 0; //stores the x coordinate for the position that is being validated
  int checkY = 0; //stores the y coordinate for the position that is currently being validated

  bool goesOffBoard = false; //boolean to specify if the move takes a peg off the board
  bool checkedAlready = false; //boolean to specify if the current position has already been checked

  //this section checks that there is an adjacent peg in the specified direction
  //calls the subprogram to get the position to be checked
  calcCheckPositions(checkX, checkY, xPos, yPos, direction, goesOffBoard, checkedAlready);
  checkedAlready = true; //got the positions once
  //check position not occupied
  if (goesOffBoard == false)
  {//if the peg does not move off the board
    if (theBoard[checkY][checkX] == '.')
    {//if there's an empty adjacent space, then the move is not legal
      cout << "There is no adjacent peg in the direction you specified." << endl;
	  //the variable moveIsLegal remains false
    }
    else if (theBoard[checkY][checkX] == 'O')
    { //if there is an adjacent peg, check the next space. If not occupied move legal.
      calcCheckPositions(checkX, checkY, xPos, yPos, direction, goesOffBoard, checkedAlready);
	  if (goesOffBoard == false)
	  {//if the peg doesn't go off the board
        if (theBoard[checkY][checkX] == '.')
	    {//if the space is empty move is valid
	      moveIsLegal = true;
	    }
	    else
	    {//if the space is occupied inform player
          cout << "The space you are moving to is occupied by another peg." << endl;
		  //the variable moveIsLegal remains false
	    }//end if
	  }//endif
    }//end if
  }//end if
  return moveIsLegal; //returns whether the move is legal or not
}
 
void movePeg(char theGameBoard[BOARD_ARRAY_SIZE_SQUARE][BOARD_ARRAY_SIZE_SQUARE], int xPosition, int yPosition, char moveDirection)
//This moves a peg into its new postion
{
  theGameBoard[yPosition][xPosition] = '.'; //puts an empty space where the peg was
  //select the correct direction to move
  switch (moveDirection)
  {//changes to the correct position on the board
    case 'N': yPosition = yPosition - 2;
		break;
	case 'E': xPosition = xPosition + 2;
		break;
	case 'S': yPosition = yPosition + 2;
		break;
	case 'W': xPosition = xPosition - 2;
		break;
	default: cout << "Error occured. The direction you specified is unrecognised." << endl;
		break;
  }//end switch
  //put peg in new position
  theGameBoard[yPosition][xPosition] = 'O';
  //step 1 back and remove the peg that has been jumped over
  switch (moveDirection)
  {
    case 'N': yPosition = yPosition + 1;
		break;
	case 'E': xPosition = xPosition - 1;
		break;
	case 'S': yPosition = yPosition - 1;
		break;
	case 'W': xPosition = xPosition + 1;
		break;
	default: cout << "Error occured. The direction you specified is unrecognised." << endl;
  }//end switch
  theGameBoard[yPosition][xPosition] = '.'; //removes jumped over peg
  //inform user peg has been moved
  cout << "The peg has been moved.\n" << endl;
}

void calcHighScore(char theBoard[BOARD_ARRAY_SIZE_SQUARE][BOARD_ARRAY_SIZE_SQUARE])
//This calculates the player's score
{
  int highScore = 0; //variable for storing the player's score
  int numPegsRemaining = 0; //varibale for storing the number of pegs remaining on the board

  //count the number of pegs remaining
  for (int i = 0; i < BOARD_ARRAY_SIZE_SQUARE; i++)
  {
    for (int j = 0; j < BOARD_ARRAY_SIZE_SQUARE; j++)
	{
	  if (theBoard[i][j] == 'O')
	  {//if there is a peg in that position, add 1 to the number of pegs
	    numPegsRemaining = numPegsRemaining + 1;
	  }
	}
  }
  //score for number of pegs left
  switch (numPegsRemaining)
  {
    case 8: highScore = 10;
		break;
	case 7: highScore = 20;
		break;
	case 6: highScore = 30;
		break;
	case 5: highScore = 40;
		break;
	case 4: highScore = 50;
		break;
	case 3: highScore = 60;
		break;
	case 2: highScore = 70;
		break;
	case 1: highScore = 80;
		break;
	default: highScore = 0;
		break;
  }
  
  //score for centre peg remaining
  if (theBoard[2][2] == 'O')
  {
    highScore = highScore + 20;
  }
  //display score
  cout << "Your score for this game is: " << highScore << endl;
}

void startNewGame(char theBoard[BOARD_ARRAY_SIZE_SQUARE][BOARD_ARRAY_SIZE_SQUARE])
//This starts a new game
{
  cout << "Recreating board..." << endl;
  //Recreates the board
  createBoard(theBoard);
  cout << "Displaying board..." << endl;
  //display the new board
  displayBoard(theBoard);
  cout << "Start game!" << endl;
}

void main() //main subprogram
{
  //Variables
  int xCoordinate = 0; //the x coordinate of the board
  int yCoordinate = 0; //the ycoordiante of the board

  char playerInput = ' '; //stores player input for starting new game
  char direction = ' '; //stores the direction peg is going to be moved
  bool inputCheck = false; //bool for checking user input is valid

  char coord = ' '; //specifies whether it is an x or y coord
  int arrayPosX = 0; //variable for storing the peg's column position in the array
  int arrayPosY = 0; //variable for storing the peg's row position in the array
  
  bool legalMove = false; //boolean for specifying if the current move is legal

  bool spaceEnmpty = false; //bool to state whether the chosen space is empty

  bool playerEndedGame = false; //boolean to specify if the player has ended the game
  bool endGameCheck = false; //bool for determining when the game ends
  char exitChar = ' '; //stores a char as a way to exit the game

  //Arrays
  //the game board represented by a 2D char array
  char gameBoard[BOARD_ARRAY_SIZE_SQUARE][BOARD_ARRAY_SIZE_SQUARE];

  //Display title
  displayTitle();

  //Display instructions
  askToDisplayInstructions();

  //Create board
  createBoard(gameBoard);

  //Display initial board
  displayBoard(gameBoard);

  while (endGameCheck == false)
  {//loops for multiple games. 
   //loop ends when the player doesn't want to play any more games
	while (legalMove == false && playerEndedGame == false)
    {//loop to keep the game looping until the player enters 0,0
      //Get coordinates
      xCoordinate = getXCoordinate(); //gets the x coordinate
      yCoordinate = getYCoordinate(); //gets the y coordinate
      
	  //if coordinates are not 0,0
      if (xCoordinate != 0 && yCoordinate != 0)
      {
      //Get direction
	  //needs coordinates to go back to peg selection
      direction = getDirection(xCoordinate, yCoordinate);
      
	  //transform the x,y coords into array elements
	  coord = 'x';
	  arrayPosX = findArrayElement(xCoordinate, coord);
	  coord = 'y';
	  arrayPosY = findArrayElement(yCoordinate, coord);

	  //Check space after next peg is empty
	  legalMove = checkMoveIsLegal(gameBoard, arrayPosX, arrayPosY, direction);
      
	  if (legalMove == true)
	  {//if the move is legal
	    //Move selected peg to space
        movePeg(gameBoard, arrayPosX, arrayPosY, direction);

        //Display the changed board
        //displayBoard(gameBoard);
	  }
	  else
	  {//if the move is not legal
	    //tell player to do their move again
        cout << "Your move was illegal for the above reason(s)." << endl;
		cout << "Please retake your move.\n" << endl;
	  }
	  //Re-display the board
      displayBoard(gameBoard);
	  legalMove = false; //resets the legal move boolean to false
	                    //so the player can do another move
      }

	  if (xCoordinate == 0 && yCoordinate == 0)
	  {//if the player enters the coordinates as 0,0 the current game ends
        cout << "Game Over" << endl;
		//legalMove = true;
		//endGameCheck = true;
		playerEndedGame = true;
	  }
	}
    
	//This section of code is executed whn the game is over
	//Calculate the player's high score
	calcHighScore(gameBoard);

    //ask if player wants to play a new game accept Y, y or N, n
    cout << "Play another game?";
    cin >> playerInput;
    //if N or n jumps out of loop
	while (inputCheck == false)
	{//loops until the player enters the correct input
	  if (playerInput == 'N' || playerInput == 'n')
	  { //if the player enters a negative response
		inputCheck = true; //input is valid
	    endGameCheck = true; //the current game has ended
	  }
	  else if (playerInput == 'Y' || playerInput == 'y')
	  { //if the player enters a positive input
		inputCheck = true; //input is valid
		//calls the subprogram to start a new game
	    startNewGame(gameBoard);
		playerEndedGame = false; //resets the end game boolean for the loop
	  }
	  else
	  {//if the input is not recognised inform the player
	    cout << "The character you entered was not recognised by this prompt." << endl;
		cout << "Please enter Y, y, N, or n." << endl;
	  }
    } //end while
	inputCheck = false;
	//} //end if
	} //end while
  //ask user to enter a key to exit the game
  cout << "\nEnter any character and press enter to exit the game.";
  cin >> exitChar;
}